net.sf.cpsolver.exam.heuristics

## Class ExamNeighbourSelection

- java.lang.Object
- - net.sf.cpsolver.exam.heuristics.ExamNeighbourSelection

- All Implemented Interfaces:
    NeighbourSelection<Exam,ExamPlacement>, TerminationCondition<Exam,ExamPlacement>

      public class ExamNeighbourSelection
      extends Object
      implements NeighbourSelection<Exam,ExamPlacement>, TerminationCondition<Exam,ExamPlacement>

  Examination timetabling neighbour selection.
  It consists of the following three phases:
  - Construction phase (`ExamConstruction` until all exams are assigned)
  - Hill-climbing phase (`ExamHillClimbing` until the given number if idle iterations)
  - Simulated annealing phase (`ExamSimulatedAnnealing` until timeout is reached)
    - Or greate deluge phase (when Exam.GreatDeluge is true, `ExamGreatDeluge` until timeout is reached)
  - At the end (when `TerminationCondition.canContinue(Solution)` is false), the search is finished with one sweep of final phase ( `ExamHillClimbing` until the given number if idle iterations).
  Version:
    ExamTT 1.2 (Examination Timetabling)
    Copyright (C) 2008 - 2010 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExamNeighbourSelection(DataProperties properties)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canContinue(Solution<Exam,ExamPlacement> currentSolution)` Termination condition (i.e., has final phase finished)
    `void` | `init(Solver<Exam,ExamPlacement> solver)` Initialization
    `boolean` | `isFinalPhase()` Is final phase
    `Neighbour<Exam,ExamPlacement>` | `selectNeighbour(Solution<Exam,ExamPlacement> solution)` Neighbour selection.
    `void` | `setFinalPhase(Callback finalPhaseFinished)` Set final phase

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ExamNeighbourSelection

          public ExamNeighbourSelection(DataProperties properties)

      Constructor
      Parameters:
        `properties` - problem properties

  - ### Method Detail

    - #### init

          public void init(Solver<Exam,ExamPlacement> solver)

      Initialization
      Specified by:
        `init` in interface `NeighbourSelection<Exam,ExamPlacement>`

    - #### selectNeighbour

          public Neighbour<Exam,ExamPlacement> selectNeighbour(Solution<Exam,ExamPlacement> solution)

      Neighbour selection. It consists of the following three phases:
      - Construction phase (`ExamConstruction` until all exams are assigned)
      - Hill-climbing phase (`ExamHillClimbing` until the given number if idle iterations)
      - Simulated annealing phase (`ExamSimulatedAnnealing` until timeout is reached)
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Exam,ExamPlacement>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment

    - #### setFinalPhase

          public void setFinalPhase(Callback finalPhaseFinished)

      Set final phase
      Parameters:
        `finalPhaseFinished` - to be called when the final phase is finished

    - #### isFinalPhase

          public boolean isFinalPhase()

      Is final phase

    - #### canContinue

          public boolean canContinue(Solution<Exam,ExamPlacement> currentSolution)

      Termination condition (i.e., has final phase finished)
      Specified by:
        `canContinue` in interface `TerminationCondition<Exam,ExamPlacement>`
      Parameters:
        `currentSolution` - current solution